﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;


namespace WpfApplication2
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void wnd_Loaded(object sender, RoutedEventArgs e)
        {
            List<ConceptDict> data = createDictionary();

            ColumnLayout colLayout = new ColumnLayout();
            colLayout.Key = "subconcepts";
            colLayout.Indentation = 0;
            colLayout.ColumnLayoutHeaderVisibility = ColumnLayoutHeaderVisibility.Never;
            colLayout.AutoGenerateColumns = false;
            colLayout.TargetTypeName = "ConceptDict";
            {
                Column _colConcept = new TextColumn();
                _colConcept.Key = "[concept_name]";
                _colConcept.HeaderText = "Scenario X";
                colLayout.Columns.Add(_colConcept);

                GroupColumn _colRGmale1 = new GroupColumn();
                _colRGmale1.Key = "Male";
                TextColumn _colmale1 = new TextColumn();
                _colmale1.Key = "[units_abs_male]";
                _colmale1.HeaderText = "Units abs";
                _colRGmale1.Columns.Add(_colmale1);
                TextColumn _colmale2 = new TextColumn();
                _colmale2.Key = "[units_per_male]";
                _colmale2.HeaderText = "Units %";
                _colRGmale1.Columns.Add(_colmale2);
                colLayout.Columns.Add(_colRGmale1);

                GroupColumn _colRGfemale1 = new GroupColumn();
                _colRGfemale1.Key = "Female";
                TextColumn _colfemale1 = new TextColumn();
                _colfemale1.Key = "[units_abs_female]";
                _colfemale1.HeaderText = "Units abs";
                _colRGfemale1.Columns.Add(_colfemale1);
                TextColumn _colfemale2 = new TextColumn();
                _colfemale2.Key = "[units_per_female]";
                _colfemale2.HeaderText = "Units %";
                _colRGfemale1.Columns.Add(_colfemale2);
                colLayout.Columns.Add(_colRGfemale1);
            }
            MyGrid.ColumnLayouts.Add(colLayout);
            
            MyGrid.ItemsSource = data;

            ExpandRows(MyGrid.Rows);

        }

        private void ExpandRows(RowCollection rows)
        {
            foreach (Row row in rows)
            {
                row.IsExpanded = true;
                if (row.HasChildren)
                {
                    // Grab this row's RowCollection, then recursively parse this collection //
                    this.ExpandRows(row.ChildBands[0].Rows);
                }
            }
        }

        private List<ConceptDict> createDictionary()
        {
            List<ConceptDict> ret = new List<ConceptDict>();

            ConceptDict newRow = new ConceptDict();
            newRow["concept_name"] = "Concept A";
            newRow["units_abs_male"] = "10";
            newRow["units_per_male"] = "10";
            newRow["units_abs_female"] = "20";
            newRow["units_per_female"] = "20%";
            ret.Add(newRow);

            newRow = new ConceptDict();
            newRow["concept_name"] = "Concept G1";
            newRow["units_abs_male"] = "10";
            newRow["units_per_male"] = "10 %";
            newRow["units_abs_female"] = "20";
            newRow["units_per_female"] = "20 %";
            ret.Add(newRow);

            ConceptDict newsubRow = new ConceptDict();
            newsubRow["concept_name"] = "   Concept B";
            newsubRow["units_abs_male"] = "10";
            newsubRow["units_per_male"] = "10 %";
            newsubRow["units_abs_female"] = "20";
            newsubRow["units_per_female"] = "20 %";
            newRow.subconcepts.Add(newsubRow);

            newsubRow = new ConceptDict();
            newsubRow["concept_name"] = "   Concept G2";
            newsubRow["units_abs_male"] = "10";
            newsubRow["units_per_male"] = "10 %";
            newsubRow["units_abs_female"] = "20";
            newsubRow["units_per_female"] = "20 %";
            newRow.subconcepts.Add(newsubRow);

            ConceptDict newsubsubRow = new ConceptDict();
            newsubsubRow["concept_name"] = "      Concept D";
            newsubsubRow["units_abs_male"] = "10";
            newsubsubRow["units_per_male"] = "10 %";
            newsubsubRow["units_abs_female"] = "20";
            newsubsubRow["units_per_female"] = "20 %";
            newsubRow.subconcepts.Add(newsubsubRow);

            newsubsubRow = new ConceptDict();
            newsubsubRow["concept_name"] = "      Concept E";
            newsubsubRow["units_abs_male"] = "10";
            newsubsubRow["units_per_male"] = "10 %";
            newsubsubRow["units_abs_female"] = "20";
            newsubsubRow["units_per_female"] = "20 %";
            newsubRow.subconcepts.Add(newsubsubRow);

            newsubRow = new ConceptDict();
            newsubRow["concept_name"] = "   Concept C";
            newsubRow["units_abs_male"] = "10";
            newsubRow["units_per_male"] = "10 %";
            newsubRow["units_abs_female"] = "20";
            newsubRow["units_per_female"] = "20 %";
            newRow.subconcepts.Add(newsubRow);

            newRow = new ConceptDict();
            newRow["concept_name"] = "Concept G3";
            newRow["units_abs_male"] = "10";
            newRow["units_per_male"] = "10 %";
            newRow["units_abs_female"] = "20";
            newRow["units_per_female"] = "20 %";
            ret.Add(newRow);

            newsubRow = new ConceptDict();
            newsubRow["concept_name"] = "   Concept F";
            newsubRow["units_abs_male"] = "10";
            newsubRow["units_per_male"] = "10 %";
            newsubRow["units_abs_female"] = "20";
            newsubRow["units_per_female"] = "20 %";
            newRow.subconcepts.Add(newsubRow);

            return ret;
        }

        private void MyGrid_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Level != 0)
            {
                RowsManager manager = e.Row.Manager as RowsManager;
                if (manager != null)
                    manager.HeaderRow.Height = new RowHeight(0);
            }  
        }
    }
}
